import * as i0 from '@angular/core';
import { EventEmitter, Component, Input, Output, ViewChild, HostListener, SecurityContext, NgModule } from '@angular/core';
import * as i1$1 from '@angular/platform-browser';
import * as i6 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import hljs from 'highlight.js';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i4 from '@angular/material/button-toggle';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import * as i2 from '@angular/cdk/clipboard';
import { ClipboardModule } from '@angular/cdk/clipboard';
import * as i3 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i5 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';

class TdCopyCodeButtonComponent {
    // private _copyCodeTooltips: ICopyCodeTooltips = {};
    copiedContent;
    copyCodeToClipboard = false;
    /**
     * copyCodeTooltips?: ICopyCodeTooltips
     *
     * Tooltips for copy button to copy and upon copying.
     */
    copyCodeTooltips = {};
    toggleRawButton = false;
    rawToggleLabels = {};
    rawToggle = false;
    toggleRaw = new EventEmitter();
    copyButton;
    rawButton;
    get copyTooltip() {
        return (this.copyCodeTooltips && this.copyCodeTooltips.copy) || 'Copy';
    }
    get copiedTooltip() {
        return (this.copyCodeTooltips && this.copyCodeTooltips.copied) || 'Copied';
    }
    get rawToggleText() {
        if (this.rawToggle) {
            return this.rawToggleLabels?.viewCode || 'View code';
        }
        else {
            return this.rawToggleLabels?.viewRaw || 'Raw';
        }
    }
    tooltip;
    textCopied(event) {
        if (event) {
            this.tooltip.hide();
            this.tooltip.message = this.copiedTooltip;
            this.tooltip.show();
        }
    }
    initializeTooltip() {
        setTimeout(() => {
            this.tooltip.message = this.copyTooltip;
        }, 200);
    }
    toggleRawClicked() {
        this.rawToggle = !this.rawToggle;
        this.toggleRaw.emit();
        this.rawButton.checked = false;
    }
    copyClicked() {
        this.copyButton.checked = false;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.1.2", ngImport: i0, type: TdCopyCodeButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.1.2", type: TdCopyCodeButtonComponent, selector: "td-copy-code-button", inputs: { copiedContent: "copiedContent", copyCodeToClipboard: "copyCodeToClipboard", copyCodeTooltips: "copyCodeTooltips", toggleRawButton: "toggleRawButton", rawToggleLabels: "rawToggleLabels" }, outputs: { toggleRaw: "toggleRaw" }, host: { listeners: { "mouseleave": "initializeTooltip()" } }, viewQueries: [{ propertyName: "copyButton", first: true, predicate: ["copyButton"], descendants: true }, { propertyName: "rawButton", first: true, predicate: ["rawButton"], descendants: true }, { propertyName: "tooltip", first: true, predicate: ["tooltip"], descendants: true }], ngImport: i0, template: "<mat-button-toggle-group\n  multiple\n  class=\"raw-and-copy-buttons\"\n  *ngIf=\"toggleRawButton; else button\"\n>\n  <mat-button-toggle (click)=\"toggleRawClicked()\" #rawButton>{{\n    rawToggleText\n  }}</mat-button-toggle>\n  <mat-button-toggle\n    [cdkCopyToClipboard]=\"copiedContent\"\n    [matTooltip]=\"copyTooltip\"\n    #tooltip=\"matTooltip\"\n    #copyButton\n    (click)=\"copyClicked()\"\n    (cdkCopyToClipboardCopied)=\"textCopied($event)\"\n  >\n    <mat-icon width>content_copy</mat-icon>\n  </mat-button-toggle>\n</mat-button-toggle-group>\n\n<ng-template #button>\n  <button\n    mat-icon-button\n    [cdkCopyToClipboard]=\"copiedContent\"\n    class=\"copy-button\"\n    [matTooltip]=\"copyTooltip\"\n    #tooltip=\"matTooltip\"\n    (cdkCopyToClipboardCopied)=\"textCopied($event)\"\n  >\n    <mat-icon role=\"img\">content_copy</mat-icon>\n  </button>\n</ng-template>\n", styles: ["mat-button-toggle-group.raw-and-copy-buttons{margin-top:-8px;margin-right:-8px;margin-left:8px}mat-button-toggle-group.raw-and-copy-buttons ::ng-deep .mat-button-toggle-label-content{font-size:12px;line-height:28px}mat-button-toggle-group.raw-and-copy-buttons ::ng-deep .mat-button-toggle-label-content mat-icon{width:16px;height:16px;font-size:16px}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.CdkCopyToClipboard, selector: "[cdkCopyToClipboard]", inputs: ["cdkCopyToClipboard", "cdkCopyToClipboardAttempts"], outputs: ["cdkCopyToClipboardCopied"] }, { kind: "component", type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: i4.MatButtonToggleGroup, selector: "mat-button-toggle-group", inputs: ["appearance", "name", "vertical", "value", "multiple", "disabled"], outputs: ["valueChange", "change"], exportAs: ["matButtonToggleGroup"] }, { kind: "component", type: i4.MatButtonToggle, selector: "mat-button-toggle", inputs: ["aria-label", "aria-labelledby", "id", "name", "value", "tabIndex", "disableRipple", "appearance", "checked", "disabled"], outputs: ["change"], exportAs: ["matButtonToggle"] }, { kind: "component", type: i5.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "directive", type: i6.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.1.2", ngImport: i0, type: TdCopyCodeButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'td-copy-code-button', template: "<mat-button-toggle-group\n  multiple\n  class=\"raw-and-copy-buttons\"\n  *ngIf=\"toggleRawButton; else button\"\n>\n  <mat-button-toggle (click)=\"toggleRawClicked()\" #rawButton>{{\n    rawToggleText\n  }}</mat-button-toggle>\n  <mat-button-toggle\n    [cdkCopyToClipboard]=\"copiedContent\"\n    [matTooltip]=\"copyTooltip\"\n    #tooltip=\"matTooltip\"\n    #copyButton\n    (click)=\"copyClicked()\"\n    (cdkCopyToClipboardCopied)=\"textCopied($event)\"\n  >\n    <mat-icon width>content_copy</mat-icon>\n  </mat-button-toggle>\n</mat-button-toggle-group>\n\n<ng-template #button>\n  <button\n    mat-icon-button\n    [cdkCopyToClipboard]=\"copiedContent\"\n    class=\"copy-button\"\n    [matTooltip]=\"copyTooltip\"\n    #tooltip=\"matTooltip\"\n    (cdkCopyToClipboardCopied)=\"textCopied($event)\"\n  >\n    <mat-icon role=\"img\">content_copy</mat-icon>\n  </button>\n</ng-template>\n", styles: ["mat-button-toggle-group.raw-and-copy-buttons{margin-top:-8px;margin-right:-8px;margin-left:8px}mat-button-toggle-group.raw-and-copy-buttons ::ng-deep .mat-button-toggle-label-content{font-size:12px;line-height:28px}mat-button-toggle-group.raw-and-copy-buttons ::ng-deep .mat-button-toggle-label-content mat-icon{width:16px;height:16px;font-size:16px}\n"] }]
        }], propDecorators: { copiedContent: [{
                type: Input
            }], copyCodeToClipboard: [{
                type: Input
            }], copyCodeTooltips: [{
                type: Input
            }], toggleRawButton: [{
                type: Input
            }], rawToggleLabels: [{
                type: Input
            }], toggleRaw: [{
                type: Output
            }], copyButton: [{
                type: ViewChild,
                args: ['copyButton']
            }], rawButton: [{
                type: ViewChild,
                args: ['rawButton']
            }], tooltip: [{
                type: ViewChild,
                args: ['tooltip']
            }], initializeTooltip: [{
                type: HostListener,
                args: ['mouseleave']
            }] } });

class TdHighlightComponent {
    _renderer;
    _elementRef;
    _domSanitizer;
    cdr;
    _initialized = false;
    _content;
    _lang = 'typescript';
    _showRaw = false;
    /**
     * content?: string
     *
     * Code content to be parsed as highlighted html.
     * Used to load data dynamically.
     *
     * e.g. `.html`, `.ts` , etc.
     */
    set content(content) {
        this._content = content;
        if (this._initialized) {
            this._loadContent(this._content);
        }
    }
    /**
     * copyCodeToClipboard?: boolean
     *
     * Display copy button on code snippets to copy code to clipboard.
     */
    copyCodeToClipboard = false;
    /**
     * copyCodeTooltips?: ICopyCodeTooltips
     *
     * Tooltips for copy button to copy and upon copying.
     */
    copyCodeTooltips = {};
    /**
     * toggleRawButton?: boolean
     *
     * Display button to toggle raw code.
     */
    toggleRawButton = false;
    /**
     * rawToggleLabels?: IRawToggleLabels
     *
     * Labels for raw toggle button.
     */
    rawToggleLabels = {};
    /**
     * lang?: string
     *
     * Language of the code content to be parsed as highlighted html.
     * Defaults to `typescript`
     *
     * e.g. `typescript`, `html` , etc.
     */
    set codeLang(lang) {
        this.setLanguage(lang);
    }
    /** @deprecated - removed completely @4.0.0 */
    set lang(lang) {
        // tslint:disable-next-line: no-console
        console.warn('DEPRECATION WARNING: switch to codeLang attribute as lang attribute is deprecated.');
        this.setLanguage(lang);
    }
    copyContent;
    /**
     * contentReady?: function
     * Event emitted after the highlight content rendering is finished.
     */
    contentReady = new EventEmitter();
    highlightComp;
    copyComp;
    tooltip;
    constructor(_renderer, _elementRef, _domSanitizer, cdr) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this._domSanitizer = _domSanitizer;
        this.cdr = cdr;
    }
    ngAfterViewChecked() {
        this.cdr.detectChanges();
    }
    ngAfterViewInit() {
        if (!this._content) {
            this._content =
                this.highlightComp.nativeElement.textContent || '';
        }
        this._loadContent(this._content);
        this._initialized = true;
    }
    setLanguage(lang) {
        if (!lang) {
            throw new Error('Error: language attribute must be defined in TdHighlightComponent.');
        }
        this._lang = lang;
        if (this._initialized) {
            this._loadContent(this._content);
        }
    }
    toggleRawClicked() {
        this._showRaw = !this._showRaw;
        this._elementRef.nativeElement.querySelector('pre').style.display = this
            ._showRaw
            ? 'none'
            : 'block';
        this._elementRef.nativeElement.querySelector('.raw').style.display = this
            ._showRaw
            ? 'block'
            : 'none';
    }
    /**
     * General method to parse a string of code into HTML Elements and load them into the container
     */
    _loadContent(code) {
        if (code && code.trim().length > 0) {
            // Clean container
            this._renderer.setProperty(this._elementRef.nativeElement, 'innerHTML', '');
            this._elementFromString(code);
            if (this.copyCodeToClipboard) {
                this._renderer.appendChild(this._elementRef.nativeElement, this.copyComp.nativeElement);
            }
        }
        this.contentReady.emit();
    }
    _elementFromString(codeStr) {
        // Renderer2 doesnt have a parsing method, so we have to sanitize and use [innerHTML]
        // to parse the string into DOM element for now.
        const preElement = this._renderer.createElement('pre');
        this._renderer.appendChild(this._elementRef.nativeElement, preElement);
        const codeElement = this._renderer.createElement('code');
        this._renderer.appendChild(preElement, codeElement);
        // Set .highlight class into <code> element
        this._renderer.addClass(codeElement, 'highlight');
        const highlightedCode = this._render(codeStr);
        codeElement.innerHTML =
            this._domSanitizer.sanitize(SecurityContext.HTML, highlightedCode) ?? '';
        if (this.toggleRawButton) {
            const divElement = this._renderer.createElement('div');
            divElement.className = 'raw';
            this._renderer.appendChild(this._elementRef.nativeElement, divElement);
            divElement.innerHTML =
                this._domSanitizer.sanitize(SecurityContext.HTML, codeStr) ?? '';
            this._renderer.setStyle(divElement, 'display', 'none');
        }
    }
    _render(contents) {
        // Trim leading and trailing newlines
        contents = contents
            .replace(/^(\s|\t)*\n+/g, '')
            .replace(/(\s|\t)*\n+(\s|\t)*$/g, '');
        // Split markup by line characters
        let lines = contents.split('\n');
        // check how much indentation is used by the first actual code line
        const firstLineWhitespaceMatch = lines[0].match(/^(\s|\t)*/);
        const firstLineWhitespace = firstLineWhitespaceMatch
            ? firstLineWhitespaceMatch[0]
            : null;
        // Remove all indentation spaces so code can be parsed correctly
        const startingWhitespaceRegex = new RegExp('^' + firstLineWhitespace);
        lines = lines.map(function (line) {
            return line
                .replace('=""', '') // remove empty values
                .replace(startingWhitespaceRegex, '')
                .replace(/\s+$/, ''); // remove trailing white spaces
        });
        const codeToParse = lines
            .join('\n')
            .replace(/\{ \{/gi, '{{')
            .replace(/\} \}/gi, '}}')
            .replace(/&lt;/gi, '<')
            .replace(/&gt;/gi, '>'); // replace with < and > to render HTML in Angular
        this.copyContent = codeToParse;
        // Parse code with highlight.js depending on language
        const highlightedCode = hljs.highlight(this._lang, codeToParse, true);
        highlightedCode.value = highlightedCode.value
            .replace(/=<span class="hljs-value">""<\/span>/gi, '')
            .replace('<head>', '')
            .replace('<head/>', '');
        return highlightedCode.value;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.1.2", ngImport: i0, type: TdHighlightComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ElementRef }, { token: i1$1.DomSanitizer }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.1.2", type: TdHighlightComponent, selector: "td-highlight", inputs: { content: "content", copyCodeToClipboard: "copyCodeToClipboard", copyCodeTooltips: "copyCodeTooltips", toggleRawButton: "toggleRawButton", rawToggleLabels: "rawToggleLabels", codeLang: "codeLang", lang: "lang" }, outputs: { contentReady: "contentReady" }, viewQueries: [{ propertyName: "highlightComp", first: true, predicate: ["highlightComponent"], descendants: true }, { propertyName: "copyComp", first: true, predicate: ["copyComponent"], descendants: true }, { propertyName: "tooltip", first: true, predicate: ["tooltip"], descendants: true }], ngImport: i0, template: "<div>\n  <div #highlightComponent>\n    <ng-content></ng-content>\n  </div>\n\n  <div #copyComponent *ngIf=\"copyCodeToClipboard\">\n    <td-copy-code-button\n      [toggleRawButton]=\"toggleRawButton\"\n      [rawToggleLabels]=\"rawToggleLabels\"\n      (toggleRaw)=\"toggleRawClicked()\"\n      [copiedContent]=\"copyContent\"\n      [copyCodeToClipboard]=\"copyCodeToClipboard\"\n      [copyCodeTooltips]=\"copyCodeTooltips\"\n    ></td-copy-code-button>\n  </div>\n</div>\n", styles: [":host ::ng-deep{overflow-x:auto;padding:16px;display:flex;position:relative}:host ::ng-deep pre,:host ::ng-deep code{font-family:Menlo,Monaco,Andale Mono,lucida console,Courier New,monospace}:host ::ng-deep pre{display:block;overflow-x:auto;padding:0;margin:0;background:transparent;font-family:Menlo,Monaco,Andale Mono,lucida console,Courier New,monospace;line-height:1.45;tab-size:2;-webkit-font-smoothing:auto;-webkit-text-size-adjust:none;text-size-adjust:none;position:relative;border-radius:2px;font-size:.8rem;width:100%}:host ::ng-deep code{margin:0;padding:0;overflow-wrap:break-word;white-space:pre-wrap}:host ::ng-deep div.raw{flex-grow:1}:host ::ng-deep .highlight{display:block;overflow-wrap:break-word;margin:0;font-family:Menlo;font-size:12px;font-weight:400;line-height:20px}:host ::ng-deep .copy-button{border:none;background:inherit;margin-top:-8px;margin-right:-8px}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: TdCopyCodeButtonComponent, selector: "td-copy-code-button", inputs: ["copiedContent", "copyCodeToClipboard", "copyCodeTooltips", "toggleRawButton", "rawToggleLabels"], outputs: ["toggleRaw"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.1.2", ngImport: i0, type: TdHighlightComponent, decorators: [{
            type: Component,
            args: [{ selector: 'td-highlight', template: "<div>\n  <div #highlightComponent>\n    <ng-content></ng-content>\n  </div>\n\n  <div #copyComponent *ngIf=\"copyCodeToClipboard\">\n    <td-copy-code-button\n      [toggleRawButton]=\"toggleRawButton\"\n      [rawToggleLabels]=\"rawToggleLabels\"\n      (toggleRaw)=\"toggleRawClicked()\"\n      [copiedContent]=\"copyContent\"\n      [copyCodeToClipboard]=\"copyCodeToClipboard\"\n      [copyCodeTooltips]=\"copyCodeTooltips\"\n    ></td-copy-code-button>\n  </div>\n</div>\n", styles: [":host ::ng-deep{overflow-x:auto;padding:16px;display:flex;position:relative}:host ::ng-deep pre,:host ::ng-deep code{font-family:Menlo,Monaco,Andale Mono,lucida console,Courier New,monospace}:host ::ng-deep pre{display:block;overflow-x:auto;padding:0;margin:0;background:transparent;font-family:Menlo,Monaco,Andale Mono,lucida console,Courier New,monospace;line-height:1.45;tab-size:2;-webkit-font-smoothing:auto;-webkit-text-size-adjust:none;text-size-adjust:none;position:relative;border-radius:2px;font-size:.8rem;width:100%}:host ::ng-deep code{margin:0;padding:0;overflow-wrap:break-word;white-space:pre-wrap}:host ::ng-deep div.raw{flex-grow:1}:host ::ng-deep .highlight{display:block;overflow-wrap:break-word;margin:0;font-family:Menlo;font-size:12px;font-weight:400;line-height:20px}:host ::ng-deep .copy-button{border:none;background:inherit;margin-top:-8px;margin-right:-8px}\n"] }]
        }], ctorParameters: () => [{ type: i0.Renderer2 }, { type: i0.ElementRef }, { type: i1$1.DomSanitizer }, { type: i0.ChangeDetectorRef }], propDecorators: { content: [{
                type: Input
            }], copyCodeToClipboard: [{
                type: Input
            }], copyCodeTooltips: [{
                type: Input
            }], toggleRawButton: [{
                type: Input
            }], rawToggleLabels: [{
                type: Input
            }], codeLang: [{
                type: Input
            }], lang: [{
                type: Input
            }], contentReady: [{
                type: Output
            }], highlightComp: [{
                type: ViewChild,
                args: ['highlightComponent']
            }], copyComp: [{
                type: ViewChild,
                args: ['copyComponent']
            }], tooltip: [{
                type: ViewChild,
                args: ['tooltip']
            }] } });

class CovalentHighlightModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.1.2", ngImport: i0, type: CovalentHighlightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.1.2", ngImport: i0, type: CovalentHighlightModule, declarations: [TdHighlightComponent, TdCopyCodeButtonComponent], imports: [CommonModule,
            ClipboardModule,
            MatIconModule,
            MatButtonToggleModule,
            MatButtonModule,
            MatTooltipModule,
            MatButtonModule], exports: [TdHighlightComponent] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.1.2", ngImport: i0, type: CovalentHighlightModule, imports: [CommonModule,
            ClipboardModule,
            MatIconModule,
            MatButtonToggleModule,
            MatButtonModule,
            MatTooltipModule,
            MatButtonModule] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.1.2", ngImport: i0, type: CovalentHighlightModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ClipboardModule,
                        MatIconModule,
                        MatButtonToggleModule,
                        MatButtonModule,
                        MatTooltipModule,
                        MatButtonModule,
                    ],
                    declarations: [TdHighlightComponent, TdCopyCodeButtonComponent],
                    exports: [TdHighlightComponent],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { CovalentHighlightModule, TdCopyCodeButtonComponent, TdHighlightComponent };
//# sourceMappingURL=covalent-highlight.mjs.map
